﻿:Namespace arrayeditor ⍝ V1.09
⍝ Implements David Liebtag's array editor as UCMD
⍝ 2015 05 21 Adam: NS header
⍝ 2015 06 01 Adam: Help auto PW
⍝ 2015 11 12 Adam: moved help layout to framework
⍝ 2017 03 07 Adam: specific help per platform and ⎕ML
⍝ 2017 07 11 Becca: add an example
⍝ 2017 07 20 Adam: auto cmd name
⍝ 2018 05 31 Adam: fallback to )ed
⍝ 2019 01 21 Adam: text tweak

    ⎕IO←1 ⋄ ⎕ML←1
    ∇ d←DESC
      :If ⎕SE.SALTUtils.WIN
          :If 80=⎕DR''
              d←'Edit a simple or mixed array of enclosures using the Array Editor from davidliebtag.com'
          :Else
              d←'Edit a simple numeric array in a GUI editor'
          :EndIf
      :Else
          d←'Edit an array using the built-in editor ─ equivalent to )ED'
      :EndIf
    ∇

    ∇ r←List
      r←⎕NS ⍬
   ⍝ Name, group, short description and parsing rules
      r.(Name Group Desc Parse)←'Edit' 'Array'DESC'1'
    ∇

    ∇ r←level Help Cmd
      r←⊂DESC
      r,←⊂'    ]',List.Group,'.',Cmd,' <arrayname>'
      :If ⎕SE.SALTUtils.WIN
      :AndIf 80=⎕DR''
      :AndIf 3≠#.⎕ML
          r,←'' 'NOTE: ⎕ML is always 3 in the Array Editor'
      :EndIf
    ∇

    ∇ r←Run(Cmd Input);name
      name←(⍕##.THIS){⍵,⍨(~∨/'#⎕'∊1↑⍵)/⍺,'.'}1⊃Input.Arguments
      :Trap 0
          name ⎕SE.NumEd.numed 0
      :Else
          ⎕ED&name
      :EndTrap
      r←0 0⍴0
    ∇


:EndNamespace ⍝ arrayeditor  $Revision: 1514 $ and ⎕ML
